%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%global provider        github
%global provider_tld    com
%global project         golang
%global repo            crypto
# https://github.com/golang/crypto
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     golang.org/x/crypto
%global commit          123391ffb6de907695e1066dc40c1ff09322aeb6
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

Name:           golang-x-crypto
Version:        0
Release:        37%{?dist}.1
Summary:        Go supplementary cryptography libraries

# Upstream license specification: BSD-3-Clause
License:        BSD
URL:            https://%{provider_prefix}
Source0:        https://%{provider_prefix}/archive/%{commit}/%{repo}-%{commit}.tar.gz

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 aarch64 %{arm}}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}

%description
Go supplementary cryptography libraries.

%package devel
Summary:       %{summary}
BuildArch:     noarch

Provides:      golang(%{import_path}/acme) = %{version}-%{release}
Provides:      golang(%{import_path}/acme/autocert) = %{version}-%{release}
Provides:      golang(%{import_path}/acme/autocert/internal/acmetest) = %{version}-%{release}
Provides:      golang(%{import_path}/argon2) = %{version}-%{release}
Provides:      golang(%{import_path}/bcrypt) = %{version}-%{release}
Provides:      golang(%{import_path}/blake2b) = %{version}-%{release}
Provides:      golang(%{import_path}/blake2s) = %{version}-%{release}
Provides:      golang(%{import_path}/blowfish) = %{version}-%{release}
Provides:      golang(%{import_path}/bn256) = %{version}-%{release}
Provides:      golang(%{import_path}/cast5) = %{version}-%{release}
Provides:      golang(%{import_path}/chacha20) = %{version}-%{release}
Provides:      golang(%{import_path}/chacha20poly1305) = %{version}-%{release}
Provides:      golang(%{import_path}/cryptobyte) = %{version}-%{release}
Provides:      golang(%{import_path}/cryptobyte/asn1) = %{version}-%{release}
Provides:      golang(%{import_path}/curve25519) = %{version}-%{release}
Provides:      golang(%{import_path}/ed25519) = %{version}-%{release}
Provides:      golang(%{import_path}/ed25519/internal/edwards25519) = %{version}-%{release}
Provides:      golang(%{import_path}/hkdf) = %{version}-%{release}
Provides:      golang(%{import_path}/internal/subtle) = %{version}-%{release}
Provides:      golang(%{import_path}/internal/wycheproof/internal/dsa) = %{version}-%{release}
Provides:      golang(%{import_path}/md4) = %{version}-%{release}
Provides:      golang(%{import_path}/nacl/auth) = %{version}-%{release}
Provides:      golang(%{import_path}/nacl/box) = %{version}-%{release}
Provides:      golang(%{import_path}/nacl/secretbox) = %{version}-%{release}
Provides:      golang(%{import_path}/nacl/sign) = %{version}-%{release}
Provides:      golang(%{import_path}/ocsp) = %{version}-%{release}
Provides:      golang(%{import_path}/openpgp) = %{version}-%{release}
Provides:      golang(%{import_path}/openpgp/armor) = %{version}-%{release}
Provides:      golang(%{import_path}/openpgp/clearsign) = %{version}-%{release}
Provides:      golang(%{import_path}/openpgp/elgamal) = %{version}-%{release}
Provides:      golang(%{import_path}/openpgp/errors) = %{version}-%{release}
Provides:      golang(%{import_path}/openpgp/packet) = %{version}-%{release}
Provides:      golang(%{import_path}/openpgp/s2k) = %{version}-%{release}
Provides:      golang(%{import_path}/otr) = %{version}-%{release}
Provides:      golang(%{import_path}/pbkdf2) = %{version}-%{release}
Provides:      golang(%{import_path}/pkcs12) = %{version}-%{release}
Provides:      golang(%{import_path}/pkcs12/internal/rc2) = %{version}-%{release}
Provides:      golang(%{import_path}/poly1305) = %{version}-%{release}
Provides:      golang(%{import_path}/ripemd160) = %{version}-%{release}
Provides:      golang(%{import_path}/salsa20) = %{version}-%{release}
Provides:      golang(%{import_path}/salsa20/salsa) = %{version}-%{release}
Provides:      golang(%{import_path}/scrypt) = %{version}-%{release}
Provides:      golang(%{import_path}/sha3) = %{version}-%{release}
Provides:      golang(%{import_path}/ssh) = %{version}-%{release}
Provides:      golang(%{import_path}/ssh/agent) = %{version}-%{release}
Provides:      golang(%{import_path}/ssh/internal/bcrypt_pbkdf) = %{version}-%{release}
Provides:      golang(%{import_path}/ssh/knownhosts) = %{version}-%{release}
Provides:      golang(%{import_path}/ssh/terminal) = %{version}-%{release}
Provides:      golang(%{import_path}/ssh/test) = %{version}-%{release}
Provides:      golang(%{import_path}/tea) = %{version}-%{release}
Provides:      golang(%{import_path}/twofish) = %{version}-%{release}
Provides:      golang(%{import_path}/xtea) = %{version}-%{release}
Provides:      golang(%{import_path}/xts) = %{version}-%{release}
Provides:      golang-ipath(golang.org/x/crypto) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for
building other packages which use import path with
%{import_path} prefix.

%prep
%setup -q -n %{repo}-%{commit}

%build

%install
# source codes for building projects
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
echo "%%dir %%{gopath}/src/%%{import_path}/." >> devel.file-list
# find all *.s and generate devel.file-list
for file in $(find . -iname "*.s") ; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
# find all *.c and generate devel.file-list
for file in $(find . -iname "*.c") ; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go") ; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done

sort -u -o devel.file-list devel.file-list

%files devel -f devel.file-list
%license LICENSE PATENTS
%doc AUTHORS CONTRIBUTING.md CONTRIBUTORS README.md

%changelog

* Thu Jan  7 23:35:35 CET 2021 Robert-André Mauchin <zebob.m@gmail.com> - 0-37.20200807git123391f.1
- Build for EPEL8
- Close: rhbz#1849189

* Fri Aug 07 18:45:47 CEST 2020 Robert-André Mauchin <zebob.m@gmail.com> - 0-0.37.20200807git123391f
- Bump to commit 123391ffb6de907695e1066dc40c1ff09322aeb6

* Tue Jul 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.36
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Tue Jul 07 00:11:41 CEST 2020 Robert-André Mauchin <zebob.m@gmail.com> - 0-0.34.20200706git75b2880
- Bump to commit 75b288015ac94e66e3d6715fb68a9b41bf046ec2

* Tue Feb 11 20:23:29 CET 2020 Robert-André Mauchin <zebob.m@gmail.com> - 0-0.34.20200211git86ce3cb
- Bump to commit 86ce3cb696783b739e41e834e2eead3e1b4aa3fb

* Wed Jan 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.33
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.32
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Fri Jul 05 2019 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0-0.31.20190416git88737f5
- Add Obsoletes for old name

* Tue Apr 16 01:12:11 CEST 2019 Robert-André Mauchin <zebob.m@gmail.com> - 0-0.30.20190416git88737f5
- Bump to commit 88737f569e3a9c7ab309cdc09a07fe7fc87233c3

* Sun Mar 24 18:28:52 CET 2019 Robert-André Mauchin <zebob.m@gmail.com> - 0-0.29.20190324gitb7391e9
- Bump to commit b7391e95e576cacdcdd422573063bc057239113d
- Security fix for #1691529 and #1691530.

* Sat Mar 02 2019 Robert-André Mauchin <zebob.m@gmail.com> - 0-0.28.20190302git8dd112b
- Bump to commit 8dd112bcdc25174059e45e07517d9fc663123347

* Fri Feb 01 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.27.gite84da03
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Oct 26 2018 Robert-André Mauchin <zebob.m@gmail.com> - 0-0.26.20181026gite84da03
- Bump to commit e84da0312774c21d64ee2317962ef669b27ffb41

* Tue Oct 23 2018 Nicolas Mailhot <nim@fedoraproject.org> - 0-0.25.gita49355c
- redhat-rpm-config-123 triggers bugs in gosetup, remove it from Go spec files as it’s just an alias
- https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/message/RWD5YATAYAFWKIDZBB7EB6N5DAO4ZKFM/

* Sun Aug 26 2018 Jan Chaloupka <jchaloup@redhat.com> - 0-0.24.gita49355c
- Rebuild to accomodate golist rebuild
  resolves: #1615497

* Mon Jul 16 2018 Steve Miller (copart) <code@rellims.com> - 0-0.23.gita49355c
- Bump to upstream a49355c7e3f8fe157a85be2f77e6e269a0f89602

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.22.git88942b9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Sat Mar 24 2018 Robert-André Mauchin <zebob.m@gmail.com> - 0-0.21.20180324git9419663
- Bump to upstream 88942b9c40a4c9d203b82b3731787b672d6e809b

* Tue Mar 06 2018 Jan Chaloupka <jchaloup@redhat.com> - 0-0.20.git9419663
- Bump to upstream 9419663f5a44be8b34ca85f08abc5fe1be11f8a3

* Mon Feb 26 2018 Jan Chaloupka <jchaloup@redhat.com> - 0-0.19.20170329gite4e2799
- Autogenerate some parts using the new macros

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.18.gite4e2799
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Aug 02 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.17.gite4e2799
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.16.gite4e2799
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Tue Jul 25 2017 Jan Chaloupka <jchaloup@redhat.com> - 0-0.15.gite4e2799
- Bump to upstream e4e2799dd7aab89f583e1d898300d96367750991
  resolves: #1474536

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.14.git81372b2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Fri Jan 13 2017 Jan Chaloupka <jchaloup@redhat.com> - 0-0.13.git81372b2
- Bump to upstream 81372b2fc2f10bef2a7f338da115c315a56b2726
  related: #1231618

* Fri Dec 16 2016 Jan Chaloupka <jchaloup@redhat.com> - 0-0.12.gitc10c31b
- Polish the spec file
  related: #1231618

* Thu Jul 21 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.11.gitc10c31b
- https://fedoraproject.org/wiki/Changes/golang1.7

* Sun Mar 06 2016 jchaloup <jchaloup@redhat.com> - 0-0.10.gitc10c31b
- Bump to upstream c10c31b5e94b6f7a0283272dc2bb27163dcea24b
  related: #1231618

* Mon Feb 22 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.9.gitc57d4a7
- https://fedoraproject.org/wiki/Changes/golang1.6

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.8.gitc57d4a7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Oct 08 2015 jchaloup <jchaloup@redhat.com> - 0-0.7.gitc57d4a7
- Fix sed for import path
  related: #1231618

* Thu Aug 20 2015 jchaloup <jchaloup@redhat.com> - 0-0.6.gitc57d4a7
- Choose the correct devel subpackage
  related: #1231618

* Wed Aug 19 2015 jchaloup <jchaloup@redhat.com> - 0-0.5.gitc57d4a7
- Update spec file to spec-2.0
  related: #1231618

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.4.gitc57d4a7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Mon Jun 15 2015 jchaloup <jchaloup@redhat.com> - 0-0.3.git%{shortcommit}
- Repository has moved to github.com/golang/crypto, updating spec file accordingly
  resolves: #1231618

* Sun Dec 14 2014 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0-0.2.hg69e2a90ed92d
- Correct Source0 URL
- Correct paths for golang.org/x/crypto/*

* Thu Dec 04 2014 jchaloup <jchaloup@redhat.com> - 0-0.1.hg69e2a90ed92d
- First package for Fedora
  resolves: #1148704
